require "statsd"
require "tweek_metrics/version"
require "tweek_metrics/handler"

module TweekMetrics
  @@config = {}
  @@statsd = nil

  def self.set_statsd_host(host)
    @@config[:statsd_host] = host
  end

  def self.set_statsd_port(port)
    @@config[:statsd_port] = port
  end

  def self.set_client(client)
    @@config[:client] = client
  end

  def self.set_namespace(namespace)
    @@config[:namespace] = namespace
  end

  def self.namespace
    @@config[:namespace]
  end

  def self.client
    @@config[:client]
  end

  def self.statsd
    @@statsd ||= Statsd.new(@@config[:statsd_host], @@config[:statsd_port])
  end

  def self.measure(instruments, key, &block)
    raise ArgumentError.new("instruments must be an Array") unless instruments.kind_of?(Array)
    raise ArgumentError.new("key must be an Array") unless key.kind_of?(Array)
    Handler.new(instruments, key, &block)
  end
end
